/**
 * @file BresenhamTest.c
 * This is the main RobotArm program start point.
 */

/**
 * Main program function.
 */

#include <propeller.h>
#include <math.h>

#include "Bresenham.h"


Bresenham B;


int main(void)
{
    _OUTA = 0;
    _DIRA |= 3;

    B.Init();
    int Ticks = 1600;

    int m1Diff = 200 * 8;
    int m2Diff = 150 * 8;
    int m3Diff = 0;

    // 1731216 cycles per 1600 ticks

    do {

        // 1536 cycles
        B.SetupMove( Ticks, m1Diff, m2Diff, m3Diff );

        // 1729680 cycles for 1600 ticks, 320,000 of which is just waitcnt
        // Excluding waitcnt, it's about 900 clocks per tick, or 220 PASM instruction cycles
        while( !B.Done() )
        {
            B.Tick();
            waitcnt( 100 + CNT );
        }

    } while(1);
}
